package ec.edu.epn.consumosriautorizacion;


import ec.edu.epn.facturacionOffline.FacturacionOfflineDTO;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.RespuestaComprobante;
import ec.gob.sri.comprobantes.ws.RespuestaSolicitud;
import java.net.URL;
import javax.xml.namespace.QName;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

@RestController
public class SriAutorizacionController {




	@GetMapping("/pruebas")
	public String pruebas(){
		return "PRUEBA EXITOSA";
	}

	@GetMapping("/recepcion/{xml}")
	public FacturacionOfflineDTO recepcion(@PathVariable String xml){

		String val = "";
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {
			RespuestaSolicitud respuesta = new RespuestaSolicitud();

			byte[] bytes = val.getBytes();

			String wsdl = "https://cel.sri.gob.ec/comprobantes-electronicos-ws/RecepcionComprobantesOffline?wsdl";
			URL url = new URL(wsdl);

			QName qname = new QName("http://ec.gob.sri.ws.recepcion", "RecepcionComprobantesOfflineService");

			RecepcionComprobantesOfflineService service = new RecepcionComprobantesOfflineService(url, qname);
			RecepcionComprobantesOffline port = service.getRecepcionComprobantesOfflinePort();  //getRecepcionComprobantesOfflinePort();

			respuesta = port.validarComprobante(bytes);

			/*PARA EL CASO DONDE EL ESTADO SEA NULL**/
			if (respuesta.getEstado() == null) {
				if (respuesta.getComprobantes() != null) {

					try {
						offlineDTO.setMensaje(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getMensaje());
					} catch (Exception e) {
						offlineDTO.setMensaje("NINGUN MENSAJE ENCOTRADO");
					}

					try {
						offlineDTO.setInfoAdicional(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
					} catch (Exception e) {
						offlineDTO.setInfoAdicional("NO DEFINIDO");
					}

					try {
						offlineDTO.setIdentificador(Integer.valueOf(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
					} catch (Exception e) {
						offlineDTO.setIdentificador(0);
					}

					try {
						offlineDTO.setTipo(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getTipo());
					} catch (Exception e) {
						offlineDTO.setTipo("ERROR");
					}

					try {
						offlineDTO.setClaveAcceso(respuesta.getComprobantes().getComprobante().get(0).getClaveAcceso());
					} catch (Exception e) {
						offlineDTO.setClaveAcceso("NO DEFINIDO");
					}

					offlineDTO.setEstado("DEVUELTA - SN");

				}
			}

			if (respuesta.getEstado().equals("DEVUELTA")) {
				try {
					offlineDTO.setMensaje(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getMensaje());
				} catch (Exception e) {
					offlineDTO.setMensaje("NINGUN MENSAJE ENCOTRADO");
				}

				try {
					offlineDTO.setInfoAdicional(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
				} catch (Exception e) {
					offlineDTO.setInfoAdicional("NO DEFINIDO");
				}

				try {
					offlineDTO.setIdentificador(Integer.valueOf(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
				} catch (Exception e) {
					offlineDTO.setIdentificador(0);
				}

				try {
					offlineDTO.setTipo(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getTipo());
				} catch (Exception e) {
					offlineDTO.setTipo("ERROR");
				}

				try {
					offlineDTO.setClaveAcceso(respuesta.getComprobantes().getComprobante().get(0).getClaveAcceso());
				} catch (Exception e) {
					offlineDTO.setClaveAcceso("NO DEFINIDO");
				}

				offlineDTO.setEstado("DEVUELTA");
			}

			if (respuesta.getEstado().equals("RECIBIDA")) {
				offlineDTO.setEstado("RECIBIDA");
			}

			System.out.println("ESTADO FACTURA  " + respuesta.getEstado());

			return offlineDTO;

		} catch (Exception e) {

			return new FacturacionOfflineDTO();
		}
	}



	@GetMapping("/autorizacion/{numAutorizacion}")
	public FacturacionOfflineDTO autorizacion(@PathVariable String numAutorizacion){
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {

			String wsdl = "https://cel.sri.gob.ec/comprobantes-electronicos-ws/AutorizacionComprobantesOffline?wsdl";
			URL url = new URL(wsdl);
			QName qname = new QName("http://ec.gob.sri.ws.autorizacion", "AutorizacionComprobantesOfflineService");
			AutorizacionComprobantesOfflineService services = new AutorizacionComprobantesOfflineService(new URL(wsdl), qname);
			AutorizacionComprobantesOffline port = services.getAutorizacionComprobantesOfflinePort();


			RespuestaComprobante respuesta = port.autorizacionComprobante(numAutorizacion);

			if(respuesta.getAutorizaciones()!=null){

				if(respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){
					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("AUTORIZADO");

					try {
						respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().setTimeZone(TimeZone.getTimeZone("ECT"));
						offlineDTO.setFechaAutorizacion(Timestamp.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().getTimeZone().toString()));
					} catch (Exception e) {

						Calendar cal = Calendar.getInstance();
						Date fechaHoy= cal.getTime();
						String DATE_FORMAT = "yyyy-MM-dd hh:mm:ss";
						TimeZone timeZone = TimeZone.getTimeZone("ECT");
						SimpleDateFormat formatterWithTimeZone = new SimpleDateFormat(DATE_FORMAT);
						formatterWithTimeZone.setTimeZone(timeZone);
						String sDate = formatterWithTimeZone.format(fechaHoy);
						SimpleDateFormat formatter = new SimpleDateFormat(DATE_FORMAT);
						Date dateWithTimeZone = formatter.parse(sDate);




						offlineDTO.setFechaAutorizacion(new Timestamp(dateWithTimeZone.getTime()));
					}

				}

				if(!respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){

					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("NO AUTORIZADO -ND");
					try {
						offlineDTO.setMensaje(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getMensaje());
					} catch (Exception e) {
						offlineDTO.setMensaje("NO DEFIIDO");
					}


					try {
						offlineDTO.setIdentificador(Integer.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
					} catch (Exception e) {
						offlineDTO.setIdentificador(0);
					}


					try {
						offlineDTO.setTipo(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getTipo());
					} catch (Exception e) {
						offlineDTO.setTipo("NO DEFINIDO");
					}

					try {
						offlineDTO.setInfoAdicional(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
					} catch (Exception e) {
						offlineDTO.setInfoAdicional("NINGNUNO");
					}
				}
			}

			if(respuesta.getNumeroComprobantes().equals("0")){
				offlineDTO.setAmbiente("PRODUCCION");
				offlineDTO.setEstado("NO AUTORIZADO SIN ENVIO RECEPCION");
				offlineDTO.setMensaje("NO DEFIIDO");
				offlineDTO.setTipo("NO DEFINIDO");
				offlineDTO.setInfoAdicional("NINGNUNO");
			}

			return offlineDTO;

		} catch (Exception e) {
			FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;
		}
	}

}
