package ec.edu.epn.facturacionOffLine;

import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.io.FileOutputStream;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.naming.InitialContext;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Document;
import com.itextpdf.text.Element;
import com.itextpdf.text.FontFactory;
import com.itextpdf.text.Image;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.Barcode128;
import com.itextpdf.text.pdf.Barcode39;
import com.itextpdf.text.pdf.BarcodeEAN;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfWriter;

import ec.edu.epn.facturacion.entities.Detallefactura;
import ec.edu.epn.facturacion.entities.Factura;
import ec.edu.epn.facturacion.entities.Pagos;
import ec.edu.epn.laboratorios.BO.ServicioBO;
import ec.edu.epn.laboratorios.entienes.Servicio;

public class GeneracionFactOfflinePDF {
	
	private ServicioBO servicioBO;
	{
		try {
			InitialContext ctx = new InitialContext();
			servicioBO = (ServicioBO) ctx
					.lookup("java:global/ServicioFacturacion/ServicioDAO!ec.edu.epn.laboratorios.BO.ServicioBO");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	

    public String generarPDFFacturaOffline(Factura factura,
            List<Detallefactura> detalle, Double total, Collection<Pagos> pagos,
            String fechaAuto, String numeroAuto, String clave) {

        String url = "";
        try {                    
            Date hoy = factura.getFechafacF();
            String hoyFecha = "";

            DateFormat fecha = new SimpleDateFormat("dd/MM/yyyy");
            DateFormat fechaMs = new SimpleDateFormat("dd/MM/yyyy hh:mm:ss");
            hoyFecha = fecha.format(hoy);
            String locate = "/FacturaUtils/";
            //String locate = "C:/facturacion_electronica/facturaUtils/";
            
            System.out.println("-->" + locate);
            
            // DOCUMENTO TIPO A4
            Document document = new Document(PageSize.A4);

            //ARCHIVO QUE SE CREA CON EL ID DE LA FACTURA
            FileOutputStream outputStream = new FileOutputStream(new File(
            												locate + factura.getIdFactura() + "-"
            												+ factura.getRucCli().trim() + ".pdf"));
            url = locate + factura.getIdFactura() + "-" + factura.getRucCli().trim() + ".pdf";            
            

            PdfWriter writer = PdfWriter.getInstance(document, outputStream);
            // SE ABRE EL ARCHIVO PARA CREAR
            document.open();
            // VARIABLE PARA OCUPAR OTRO PDF COMO PLANTILLA
            PdfContentByte cb = writer.getDirectContent();
            
            // CARGA DE LA PLANTILLA
            String path = locate + "Plantilla2.pdf";

            PdfReader reader = new PdfReader(path);
            // GENERAMOS UNA PAGINA
            PdfImportedPage page = writer.getImportedPage(reader, 1);

            // PONEMOS LA PLANTILLA DENTRO DEL DOCUMENTO CREAR PARA TNENER LA PLANTILLA
            document.newPage();
            cb.addTemplate(page, 0, 0);

            // CREACION DE CONTENIDO INICIO Y NUMERO DE LA FACTURA
            PdfPTable datosFactura = new PdfPTable(2);

            datosFactura.setWidthPercentage(100);
            datosFactura.getDefaultCell().setBorder(0);
            float[] columnWidths1 = new float[]{50f, 50f};
            datosFactura.setWidths(columnWidths1);  
            

            Image img = Image.getInstance(locate + "epn_cabecera.png");
            img.scalePercent(50);
            img.setAlignment(Element.ALIGN_CENTER);
            img.scalePercent(25f);
            img.setAbsolutePosition(250f, 620f);  
            img.setBorder(0);
            datosFactura.addCell(img);        
            
            
            Image imgD = createBarcode39Extended(factura.getNumautoriza(), writer);
            imgD.setAlignment(Element.ALIGN_CENTER);
            imgD.setBorder(0);
            
            PdfPTable codBarras = new PdfPTable(1);
            //codBarras.getDefaultCell().setBorder(0);
            
            codBarras.addCell(createLabelCell2(
            						"R.U.C.:		1760005620001"  + "\n\n"
            						+ "FACTURA" + "\n\n"            								
            						+ "No. " + factura.getIdFactura() + "\n\n"
            						+ "NMERO DE AUTORIZACIN" + "\n\n"
            						+ factura.getNumautoriza() + "\n\n"
            						+ "FECHA Y HORA DE 		" + factura.getFechaautoriza() + "\n"
            						+ "AUTORIZACIN:" + "\n\n"
            						+ "AMBIENTE:		" + factura.getAmbiente()  + "\n\n"
            						+ "EMISIN:		" + factura.getEmision() + "\n\n"
            						+ "	CLAVE DE ACCESO" + "\n\n"));
            
            
            
            codBarras.addCell(imgD);
            
            datosFactura.addCell(codBarras);
            
            
            document.add(datosFactura);
            
            Paragraph datosEspacio1 = new Paragraph();
            datosEspacio1.add("\n");
            datosEspacio1.setFont(FontFactory.getFont(FontFactory.TIMES_ROMAN, 10,Font.ITALIC));            
            document.add(datosEspacio1);

            // CREANDO CONTENIDO CABECERA ANTES DE LA TABLA DE DETALLE
            com.itextpdf.text.Font fuente = FontFactory.getFont(
                    FontFactory.TIMES_ROMAN, 10, Font.BOLD);            
            PdfPTable datoscabecera = new PdfPTable(1);

            datoscabecera.setWidthPercentage(100);
            datoscabecera.addCell(createLabelCell3(
            						"Razn Social/ Nombres y Apellidos:\t\t\t\t\t\t\t\t\t  " + factura.getNombreCli() + "\n" 
            						+  "\t\t\t\tidentificacin:"  + factura.getRucCli()  + "\n\n"            						
            						+ "Fecha Emisin:	" + hoyFecha));            

            document.add(datoscabecera);

            Paragraph datosContrato = new Paragraph();

            fuente = FontFactory.getFont(FontFactory.TIMES_ROMAN, 10,
                    Font.ITALIC);

            datosContrato.add("\n");
            datosContrato.setFont(fuente);            
            document.add(datosContrato);

            // CARGA ACADEMICA EN TABLA
            PdfPTable datosfactura = new PdfPTable(10);

            datosfactura.setWidthPercentage(100);            
            float[] columnWidths = new float[]{18f, 18f, 22f, 60f, 22f, 22f, 22f, 22f, 22f, 30f};
            datosfactura.setWidths(columnWidths);
            
            datosfactura.addCell(createLabelCell("Cod. Principal"));
            datosfactura.addCell(createLabelCell("Cod. Auxiliar"));
            datosfactura.addCell(createLabelCell("Cant."));
            datosfactura.addCell(createLabelCell("Descripcin"));
            datosfactura.addCell(createLabelCell("Detalle Adicional 1"));
            datosfactura.addCell(createLabelCell("Detalle Adicional 2"));
            datosfactura.addCell(createLabelCell("Detalle Adicional 3"));
            datosfactura.addCell(createLabelCell("Precio Unitario"));
            datosfactura.addCell(createLabelCell("Descuento"));
            datosfactura.addCell(createLabelCell("Precio Total"));
           
         

            for (Detallefactura det : detalle) {
                if (det.getIdServicio() == null || det.getIdServicio().equals("")) {
                    datosfactura.addCell(createLabelCell4(det.getConcepto().getIdConcepto()));
                    datosfactura.addCell(createLabelCell4(det.getConcepto().getIdConcepto()));
                    datosfactura.addCell(createLabelCell4(det.getUnidadesDf().toString()));
                    
                    if (det.getNombreser() != null) {
                        datosfactura.addCell(createLabelCell4(det.getNombreser()
                                + "\n\n"));
                    } else {
                        datosfactura.addCell(createLabelCell4(det.getConcepto().getNombreConcp()
                                + "\n\n"));
                    }
                } else {
                	Servicio servicio = (Servicio) servicioBO.getById(Servicio.class,det.getIdServicio());
					
					if(servicio==null){
						if(det.getConcepto()!=null){
							 datosfactura.addCell(createLabelCell4(det.getConcepto().getIdConcepto()));
			                 datosfactura.addCell(createLabelCell4(det.getConcepto().getIdConcepto()));
			                 datosfactura.addCell(createLabelCell4(det.getUnidadesDf().toString()));
			                 datosfactura.addCell(createLabelCell4(det.getConcepto().getNombreConcp() + "\n\n"));
						}
					}else{
						datosfactura.addCell(createLabelCell4(det.getIdServicio()));
	                    datosfactura.addCell(createLabelCell4(det.getIdServicio()));
	                    datosfactura.addCell(createLabelCell4(det.getUnidadesDf().toString()));
	                    datosfactura.addCell(createLabelCell4(getDescrConcepto(det.getIdServicio())));
					}
                    
                }
                datosfactura.addCell(createLabelCell4("")); //---------------DETALLE ADICIONAL 1
                datosfactura.addCell(createLabelCell4("")); //---------------DETALLE ADICIONAL 2
                datosfactura.addCell(createLabelCell4("")); //---------------DETALLE ADICIONAL 3                
                datosfactura.addCell(createLabelCell4(String.valueOf(new BigDecimal(det 
                        .getCostoDf()).setScale(2, 
                                RoundingMode.HALF_UP)))); //------------PRECIO UNITARIO
                datosfactura.addCell(createLabelCell4(String.valueOf(new BigDecimal(0).setScale(2,
                               RoundingMode.HALF_UP)))); //---------------DESCUENTO
                datosfactura.addCell(createLabelCell4(String.valueOf(new BigDecimal(det
                        .getCostotDf()).setScale(2, // -----------------PRECIO TOTAL
                                RoundingMode.HALF_UP))));

            }
            
            /**SE PRESENTA LOS PAGOS QUE SE REALIZARON*/
            
            String pagosF = "";
            if(pagos!=null){
            	for (Pagos pag : pagos) {                    
                    pagosF += "     " + pag.getFormaPago().getNombreFp() + ": " 
                    		+ new BigDecimal(pag.getMontoPa().doubleValue()).setScale(2, RoundingMode.HALF_UP).toString() + "\n\n" ; 
                }
            }

            PdfPTable tblInfAdicional = new PdfPTable(1);
            tblInfAdicional.setWidthPercentage(50);
            PdfPCell celda;
            PdfPCell celdaInfAdicional;
            
            com.itextpdf.text.Font fuente1 = FontFactory.getFont(
                    FontFactory.TIMES_ROMAN, 9);

            String text = "			Informacin Adicional " + "\n\n"
                    + "Direccin:		" + factura.getDireccionCli() + "\n\n"
                    + "Telfono:		" + factura.getTelefonoCli() + "\n\n" 
                    + "Email:		" + factura.getEmailCl() + "\n\n"
            		+ "Forma de Pago:		" + pagosF;
            celdaInfAdicional = new PdfPCell(new Phrase(text, fuente1));
            celdaInfAdicional.setHorizontalAlignment(Element.ALIGN_LEFT);
            celdaInfAdicional.setVerticalAlignment(Element.ALIGN_MIDDLE);
            celdaInfAdicional.setPaddingLeft(6);            
            
            // LA CELDA TOMA 2 ESPACIOS VERTICALES
            
            tblInfAdicional.addCell(celdaInfAdicional);
            
            celda = new PdfPCell(tblInfAdicional);
            celda.setRowspan(11);
            celda.setColspan(6);
            
            

            celda.setHorizontalAlignment(Element.ALIGN_LEFT);
            celda.setVerticalAlignment(Element.ALIGN_MIDDLE);
            celda.setBorder(0);            
            datosfactura.addCell(celda);
            
            
            String textEsp= "";
            PdfPCell celdaEsp;
            celdaEsp = new PdfPCell(new Phrase(textEsp, fuente1));            
            celdaEsp.setRowspan(11);
            celdaEsp.setColspan(1);
            celdaEsp.setBorder(0);
            datosfactura.addCell(celdaEsp);
            
            //SUBTOTAL...           
            
            PdfPCell celda1;
            PdfPCell celda2;
            celda1 = new PdfPCell(new Phrase("SUBTOTAL 12%", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            
            datosfactura.addCell(celda1);
            
            
            /**SE REALIZA UN DESGLOSE DE LOS VALORES CON IVA Y SIN IVA*/
            
            double val= 0.0;
            BigDecimal subTotalIva= new BigDecimal(val).setScale(2, RoundingMode.HALF_UP);            
            BigDecimal subTotalSinIva= new BigDecimal(val).setScale(2, RoundingMode.HALF_UP);
            for (Detallefactura det : detalle) {
            	if(det.getPorcentajeiva() == null || det.getPorcentajeiva().intValue() == 0){
            		subTotalSinIva= subTotalSinIva.add(new BigDecimal(det.getCostotDf()).setScale(2, RoundingMode.HALF_UP));
            	}else if(det.getPorcentajeiva().toString().contains("12")){
            		subTotalIva= subTotalIva.add(new BigDecimal(det.getCostotDf()).setScale(2, RoundingMode.HALF_UP));
            	}            	
            	
            }
           
             
           celda2 = new PdfPCell(new Phrase(subTotalIva.toString(), fuente1));
           
           
                        
            celda2.setRowspan(1);
            celda2.setColspan(1);            
            datosfactura.addCell(celda2);
            
            
            celda1 = new PdfPCell(new Phrase("SUBTOTAL 0%", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
           
           
           celda2 = new PdfPCell(new Phrase(subTotalSinIva.toString(), fuente1));
           
            
            celda2.setRowspan(1);
            celda2.setColspan(1);            
            datosfactura.addCell(celda2);
            
            
            celda1 = new PdfPCell(new Phrase("SUBTOTAL no objeto de IVA", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
            
            
           
            celda1 = new PdfPCell(new Phrase("SUBTOTAL Exento de IVA", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);          
                        
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
          
            
            celda1 = new PdfPCell(new Phrase("SUBTOTAL SIN IMPUESTOS", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            BigDecimal stFac1 = new BigDecimal(factura.getSubtotalF()).setScale(2, RoundingMode.HALF_UP);    
            celda2 = new PdfPCell(new Phrase(stFac1.toString(), fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
           
            
            
            celda1 = new PdfPCell(new Phrase("TOTAL Descuento", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);            
            
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
            
           
            
            celda1 = new PdfPCell(new Phrase("ICE", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);            
           
            
            celda1 = new PdfPCell(new Phrase("IVA 12%", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);            
            
            celda2 = new PdfPCell(new Phrase(new BigDecimal(factura.getIvaF())
									.setScale(2,RoundingMode.HALF_UP).toString(), fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
            
           
            
            celda1 = new PdfPCell(new Phrase("IRBPNR", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
            
            
            
            
            celda1 = new PdfPCell(new Phrase("PROPINA", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            celda2 = new PdfPCell(new Phrase("0.00", fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
            
            
            celda1 = new PdfPCell(new Phrase("VALOR TOTAL", fuente1));
            celda1.setRowspan(1);
            celda1.setColspan(2);
            datosfactura.addCell(celda1);
            
            celda2 = new PdfPCell(new Phrase(new BigDecimal(factura.getTotalF())
								.setScale(2, RoundingMode.HALF_UP).toString(), fuente1));
            celda2.setRowspan(1);
            celda2.setColspan(1);
            datosfactura.addCell(celda2);
           
            document.add(datosfactura);
            
            document.close();
            writer.close();
            cb.closePath();
            reader.close();
            page.closePath();

        } catch (Exception e) {
            e.printStackTrace();

            url = "";
        }
        return url;
    }

   
    private static PdfPCell createLabelCell(String text) {
        // font
        com.itextpdf.text.Font fuente = FontFactory.getFont(
                FontFactory.TIMES_ROMAN, 10, Font.BOLD);

        // create cell
        PdfPCell cell = new PdfPCell(new Phrase(text, fuente));

        cell.setHorizontalAlignment(Element.ALIGN_CENTER);
        cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
        cell.setBackgroundColor(BaseColor.LIGHT_GRAY);

        // set style
        return cell;
    }


  
    private static PdfPCell createLabelCell2(String text) {
        // font
        com.itextpdf.text.Font fuente = FontFactory.getFont(
                FontFactory.TIMES_ROMAN, 10, Font.BOLD);

        // create cell
        PdfPCell cell = new PdfPCell(new Phrase(text, fuente));

        cell.setHorizontalAlignment(Element.ALIGN_LEFT);
        cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
        //cell.setBorder(0);
        
        return cell;
    }

   
    private static PdfPCell createLabelCell3(String text) {
        // font
        com.itextpdf.text.Font fuente = FontFactory.getFont(
                FontFactory.TIMES_ROMAN, 9, Font.BOLD);

        // create cell
        PdfPCell cell = new PdfPCell(new Phrase(text, fuente));

        cell.setHorizontalAlignment(Element.ALIGN_LEFT);

        // set style
        return cell;
    }

    
    private static PdfPCell createLabelCell4(String text) {
        // font
        com.itextpdf.text.Font fuente = FontFactory.getFont(
                FontFactory.TIMES_ROMAN, 9);

        // create cell
        PdfPCell cell = new PdfPCell(new Phrase(text, fuente));

        cell.setHorizontalAlignment(Element.ALIGN_LEFT);
        cell.setVerticalAlignment(Element.ALIGN_MIDDLE);

        // set style
        return cell;
    }

    @SuppressWarnings("unused")
    private Image getBarcode(Document document, PdfWriter pdfWriter,
            String servicio, String codigoTransaccion) {
        PdfContentByte cimg = pdfWriter.getDirectContent();
        Barcode39 code39 = new Barcode39();

        code39.setCode(servicio + codigoTransaccion);
        code39.setCodeType(Barcode39.CODE128);
        code39.setTextAlignment(Element.ALIGN_CENTER);

        Image image = code39.createImageWithBarcode(cimg, null, null);
        java.awt.Image im = code39.createAwtImage(Color.BLACK, Color.WHITE);
        float scaler = ((document.getPageSize().getWidth()
                - document.leftMargin() - document.rightMargin() - 100) / image.getWidth()) * 75;
        image.scalePercent(scaler);
        image.setAlignment(Element.ALIGN_CENTER);

        return image;
    }
    
    
    public Image createBarcode39Extended(String myText, PdfWriter writer) {
    	PdfContentByte pdfContentByte = writer.getDirectContent();

        Barcode128 barcode128 = new Barcode128();
        barcode128.setCode(myText);
       barcode128.setCodeType(Barcode128.CODE128);
        Image code128Image = barcode128.createImageWithBarcode(pdfContentByte, null, null);
       code128Image.scalePercent(50);
        return code128Image;
    }
    
    
    public Image createBarcodeEAN(String myText, PdfWriter writer) {
    	PdfContentByte pdfContentByte = writer.getDirectContent();
    	BarcodeEAN barcodeEAN = new BarcodeEAN();
    	barcodeEAN.setCodeType(BarcodeEAN.EAN13);
    	barcodeEAN.setCode(myText);
    	Image codeEANImage = barcodeEAN.createImageWithBarcode(pdfContentByte, null, null);
    	codeEANImage.setAbsolutePosition(20, 20);
    	codeEANImage.scalePercent(10);
    	codeEANImage.scalePercent(30f);
    	
    	return codeEANImage;

    }
    
    public String getDescrConcepto(String idServicio)
    {
    	try {
			return servicioBO.findString(null, null, null, 
					idServicio, null, null, 
					null, null, null, 
					"Servicio.findByIdServicio", Servicio.class);
		} catch (Exception e) {			
			e.printStackTrace();
			return null;
		}
    }


}


